package de.hhu.ba.yoshikoWrapper.tasks;

import java.util.ArrayList;

import org.cytoscape.model.subnetwork.CySubNetwork;
import org.cytoscape.view.layout.CyLayoutAlgorithm;
import org.cytoscape.view.model.CyNetworkView;
import org.cytoscape.work.Task;
import org.cytoscape.work.TaskMonitor;

import de.hhu.ba.yoshikoWrapper.core.CyCore;
import de.hhu.ba.yoshikoWrapper.core.LocalizationManager;
import de.hhu.ba.yoshikoWrapper.cytoUtil.StyleManager;
import de.hhu.ba.yoshikoWrapper.graphModel.YoshikoCluster;

public class CreateClusterViews implements Task {

	private ArrayList<YoshikoCluster> clusters;

	public CreateClusterViews(ArrayList<YoshikoCluster> clusters) {
		this.clusters = clusters;
	}

	@Override
	public void run(TaskMonitor taskMonitor) throws Exception {
		CyLayoutAlgorithm layout = CyCore.layoutAlgorithmManager.getDefaultLayout();
		for (YoshikoCluster c : clusters) {
			CySubNetwork subnet = c.getSubNetwork();
			taskMonitor.setStatusMessage(LocalizationManager.get("status_createCV")+" "+(c.getID()+1));
			CyCore.networkManager.addNetwork(subnet);
			//Create network view and register it
			CyNetworkView subnetView = CyCore.networkViewFactory.createNetworkView(subnet);
			//layout cluster
			CyCore.dialogTaskManager.execute(
				layout.createTaskIterator(
						subnetView,
						layout.getDefaultLayoutContext(),
						CyLayoutAlgorithm.ALL_NODE_VIEWS,
						null
				)
			);

			StyleManager.style(subnetView,CyCore.visualMappingManager.getCurrentVisualStyle());

			CyCore.networkViewManager.addNetworkView(subnetView);
		}
	}

	@Override
	public void cancel() {}

}
